var express = require('express');
var bodyParser = require('body-parser');
var multer = require('multer');
var mongoClient = require('mongodb').MongoClient;
//configure mongoDBUri:
var mongoDBuri = "mongodb://localhost:27017/ubiHealth"

var app = express();
app.use(express.static(__dirname + '/public'));
app.use(bodyParser.json());
app.use(bodyParser.urlencoded({extended: true}));
app.use(multer());
app.disable('etag');
app.disable('x-powered-by');

require('./file_upload.js')(app, mongoClient, mongoDBuri);
require('./doctors.js')(app, mongoClient, mongoDBuri);
require('./patients.js')(app, mongoClient, mongoDBuri);
require('./example.js')(app, mongoClient, mongoDBuri);
require('./serialportOperation.js')(app,mongoClient,mongoDBuri);

exports.app = app;
module.exports = exports;
