var querystring = require("querystring");

module.exports = function(app, mongoClient, mongoDBuri) {

app.post('/testPatients', function(req, res){
        console.log("testPatients");
        res.writeHead(200, {"Content-Type": "text/plain","Access-Control-Allow-Origin":"*"});
        var findReqToString = querystring.stringify(req.body);
        console.log("result: "+findReqToString);
        res.write(JSON.stringify(findReqToString));
        res.end();
});

//This method is used during patient registration, to check if there is already an user with same patientID or same Patient name: parameters are patientid and patientname.
//It will return documents from 'PatientInfo' collection with query with 'patientid' and 'patientname'
app.post('/patientregisterationcheck', function(req, res) {
	console.log("patient registeration check");
	res.writeHead(200,{"Content-Type":"text/plain","Access-Control-Allow-Origin":"*"});

    var findReqToString = querystring.stringify(req.body);
	var patient_iD = querystring.parse(findReqToString).patientid;
	var patient_name = querystring.parse(findReqToString).patientname;

	var collection_name = "PatientInfo";
        var collection;

        mongoClient.connect(mongoDBuri, function(err,database){
                if(err){
                        console.log("Error connecting to db");
                        res.writeHead(200,{"Content-Type":"text/plain"});
                        res.write("DB connection failed.");
                        res.end();
                } else {
                        var db = database;
                        console.log("Connected to db");
                        collection = db.collection(collection_name);
            	        console.log("At PatientInfo collection.");

		    	        collection.find({PatientID:patient_iD, PatientName:patient_name}).toArray(function(err,records){
			            	res.write(JSON.stringify(records));
		            		res.end();
	            			console.log(records.length);
			            });
                }
        });

});

//inserting new user into PatientInfo collection postData will be send with all the fields
//It will insert documents in 'PatientInfo' collection
app.post('/patientregistrationinsert', function(req, res) {
	console.log("Patient registration insert requested.");
	var collection_name = "PatientInfo";
	var collection;
    console.log(req.body);
        mongoClient.connect(mongoDBuri, function(err,database){
                if(err){
                        console.log("Error connecting to db");
                        res.writeHead(200,{"Content-Type":"text/plain"});
                        res.write("DB connection failed.");
                        res.end();
                } else {
                        var db = database;
                        console.log("at patient info collection");
                        collection = db.collection(collection_name);
			console.log("At PatientInfo collection.");
			collection.insert(req.body, function(err, result) {
				if (err) {
					console.log("Error at inserting data.");
					console.log(err);
				} else {
					console.log('Inserted %d documents into the "PatientInfo" collection.');
					res.write('Inserted info to "PatientInfo" collection.');
                    res.end();
				}
			});

                }
        });

});

app.post('/patientLookUpDataByDate', function(req, res) {
    console.log("patientLookUpDataByDate requested");
	res.writeHead(200, {"Content-Type": "text/plain","Access-Control-Allow-Origin":"*"});
    var findReqToString = querystring.stringify(req.body);
	var patient_iD = querystring.parse(findReqToString).patientID;
    var start = new Date(querystring.parse(findReqToString).start);
    var finish = new Date(querystring.parse(findReqToString).finish);
    console.log('patient_iD: '+patient_iD);
    console.log('start date: ' + start);
    console.log('end date: ' + finish);
    var collection_name = "PatientData";
    var collection;

    mongoClient.connect(mongoDBuri, function(err,database){
        if(err){
            console.log("Error connectiong to db");
            res.writeHead(200,{"Content-Type":"text/plain"});
            res.write("DB connection failed.");
            res.end();
        } else {
            var db = database;
            var opt = {sort:[['CreatedDate',-1]]}
            console.log("Connected to db");
            collection = db.collection(collection_name);
            console.log({created_date:{$gte:start,$lt:finish}});
            //query collection "first_name"_"last_name" for all docs between start and finish
            collection.find({PatientID:patient_iD,CreatedDate:{$gte:start,$lt:finish}},{},opt).toArray(function(err,records){
                res.write(JSON.stringify(records));
                res.end();
                console.log(records.length);
            });

        }
    });
});

//PatientLog in match ID and password
//It will return documents from 'PatientInfo' collection with query with 'patientid' and 'patientpassword'
app.post('/patientLogincheak', function(req, res) {
	console.log("Patient login check requested.");
	res.writeHead(200, {"Content-Type": "text/plain","Access-Control-Allow-Origin":"*"});

    var findReqToString = querystring.stringify(req.body);
	var patient_iD = querystring.parse(findReqToString).patientid;
	var patient_password = querystring.parse(findReqToString).patientpassword;

	var collection_name = "PatientInfo";
	var collection;

        mongoClient.connect(mongoDBuri, function(err,database){
                if(err){
                        console.log("Error connecting to db");
                        res.writeHead(200,{"Content-Type":"text/plain"});
                        res.write("DB connection failed.");
                        res.end();
                } else {
                        var db = database;
                        console.log("Connected to db");
                        collection = db.collection(collection_name);
                        console.log("At PatientInfo collection.");

    //query collection "first_name"_"last_name" for all docs between start and finish
    collection.find({PatientID:patient_iD, PatientPassword:patient_password}).toArray(function(err,records){
       res.write(JSON.stringify(records)); 
       res.end();
       console.log(records.length);
    });
                }
        });
});


//patientcommentretrieve
app.post('/patientcommentretrieve', function(req, res) {
    console.log("patientcommentretrieve requested.");
    res.writeHead(200, {"Content-Type": "text/plain","Access-Control-Allow-Origin":"*"});

    var findReqToString = querystring.stringify(req.body);
    var patient_iD = querystring.parse(findReqToString).patientid;

    var collection_name = "Comment";
    var collection;

        mongoClient.connect(mongoDBuri, function(err,database){
                if(err){
                        console.log("Error connecting to db");
                        res.writeHead(200,{"Content-Type":"text/plain"});
                        res.write("DB connection failed.");
                        res.end();
                } else {
                        var db = database;
                        console.log("Connected to db");
                        collection = db.collection(collection_name);
                        console.log("At Comment collection.");

                        collection.find({PatientID:patient_iD}).toArray(function(err,records){
                           if(err){
                              res.write("error on getting data");
                           }
                           res.write(JSON.stringify(records));
                           res.end();
                           console.log(records.length);
                         });
                }
        });
});

// patientalldataget

app.post('/patientalldataretrieve', function(req, res) {

    res.writeHead(200, {"Content-Type": "text/plain","Access-Control-Allow-Origin":"*"});

    var findReqToString = querystring.stringify(req.body);
    var patient_iD = querystring.parse(findReqToString).patientID;

    var collection_name = "PatientData";
    var collection;

        mongoClient.connect(mongoDBuri, function(err,database){
                if(err){
                        console.log("Error connecting to db");
                        res.writeHead(200,{"Content-Type":"text/plain"});
                        res.write("DB connection failed.");
                        res.end();
                } else {
                        var db = database;
                        var opt = {sort:[['CreatedDate',-1]]}
                        console.log("Connected to db");
                        collection = db.collection(collection_name);
                        console.log("At Comment collection.");

                        collection.find({PatientID:patient_iD},{},opt).toArray(function(err,records){
                           if(err){
                              res.write("error on getting data");
                           }
                           res.write(JSON.stringify(records));
                           res.end();
                           console.log(records.length);
                         });
                }
        });
});

app.post('/patientdatainsert', function(req, res) {
    console.log("Patient registration insert requested.");
    var postObjectToString = querystring.stringify(req.body);
    var postObject = querystring.parse(postObjectToString);
    postObject['CreatedDate'] = new Date();
    console.log("Inserting following data: " + querystring.stringify(postObject,';',':'));

    var collection_name = "PatientData";
    var collection;
    console.log(req.body);
    mongoClient.connect(mongoDBuri, function(err,database){
                if(err){
                        console.log("Error connecting to db");
                        res.writeHead(200,{"Content-Type":"text/plain"});
                        res.write("DB connection failed.");
                        res.end();
                } else {
                        var db = database;
                        console.log("at patient info collection");
                        collection = db.collection(collection_name);
			console.log("At PatientInfo collection.");
                collection.insert(postObject,function(err,records){});
                res.writeHead(200,{"Content-Type":"text/plain","Access-Control-Allow-Origin":"*"});
                res.write("Inserted " + querystring.stringify(postObject,';',':') + " into " + collection_name);
                res.end();
                }
        });

});

app.post('/patientmostrecent', function(req, res){
    console.log('patientmostrecent request');
    res.writeHead(200, {"Content-Type": "text/plain","Access-Control-Allow-Origin":"*"});

    var findReqToString = querystring.stringify(req.body);
    var patient_ID = querystring.parse(findReqToString).patientID;
    console.log('patient_ID: ' + patient_ID);
    var collection_name = "PatientData";
    var collection;

        mongoClient.connect(mongoDBuri, function(err,database){
                if(err){
                        console.log("Error connecting to db");
                        res.writeHead(200,{"Content-Type":"text/plain"});
                        res.write("DB connection failed.");
                        res.end();
                } else {
                        var db = database;
                        var opt = {"limit":1,sort:[['CreatedDate',-1]]};
                        console.log("At PatientData collection");
                        collection = db.collection(collection_name);

                        //query collection patient_ID for all docs between start and finish
                        collection.find({PatientID:patient_ID},{},opt).toArray(function(err,records){
                            res.write(JSON.stringify(records));
                            res.end();
                            console.log(records.length);
                        });
                }
        });

});


//Patient zipcode retriver with match ID
//It will return documents from 'PatientData' collection with query with 'patientid'
app.post('/patientZipCode', function(req, res) {
	console.log("Patient login check requested.");
	res.writeHead(200, {"Content-Type": "text/plain","Access-Control-Allow-Origin":"*"});

    var findReqToString = querystring.stringify(req.body);
	var patient_iD = querystring.parse(findReqToString).patientid;

	var collection_name = "PatientInfo";
	var collection;

        mongoClient.connect(mongoDBuri, function(err,database){
                if(err){
                        console.log("Error connecting to db");
                        res.writeHead(200,{"Content-Type":"text/plain"});
                        res.write("DB connection failed.");
                        res.end();
                } else {
                        var db = database;
                        console.log("Connected to db");
                        collection = db.collection(collection_name);
                        console.log("At PatientInfo collection.");

    //query collection "first_name"_"last_name" for all docs between start and finish
    collection.find({PatientID:patient_iD},{ZipCode:1}).toArray(function(err,records){
       res.write(JSON.stringify(records)); 
       res.end();
       console.log(records.length);
    });
                }
        });
});

//Patient country retriver with match ID
//It will return documents from 'PatientData' collection with query with 'patientid'
app.post('/patientCountry', function(req, res) {
	console.log("Patient login check requested.");
	res.writeHead(200, {"Content-Type": "text/plain","Access-Control-Allow-Origin":"*"});

    var findReqToString = querystring.stringify(req.body);
	var patient_iD = querystring.parse(findReqToString).patientid;

	var collection_name = "PatientInfo";
	var collection;

        mongoClient.connect(mongoDBuri, function(err,database){
                if(err){
                        console.log("Error connecting to db");
                        res.writeHead(200,{"Content-Type":"text/plain"});
                        res.write("DB connection failed.");
                        res.end();
                } else {
                        var db = database;
                        console.log("Connected to db");
                        collection = db.collection(collection_name);
                        console.log("At PatientInfo collection.");

    collection.find({PatientID:patient_iD},{Country:1}).toArray(function(err,records){
       res.write(JSON.stringify(records));
       res.end();
       console.log(records.length);
    });
                }
        });
});



};
